{-| Module  : FiniteCategories
Description : Tests the parsing of fscg files.
Copyright   : Guillaume Sabbagh 2021
License     : GPL-3
Maintainer  : guillaumesabbagh@protonmail.com
Stability   : experimental
Portability : portable

Tests the parsing of fscg files.
-}
module ExampleParsers.ExampleSafeCompositionGraphFunctor
(
    main
)
where
    import              IO.Parsers.Lexer
    import              IO.Parsers.SafeCompositionGraphFunctor
    import              CompositionGraph.SafeCompositionGraph
    import              ExportGraphViz.ExportGraphViz
    import              Diagram.Conversion
    import              Diagram.Diagram
    import              IO.PrettyPrint

    -- | Export the arrow category as a pdf with GraphViz.
    main = do 
        putStrLn "Start of ExampleSafeCompositionGraphFunctor"
        diag <- readFSCGFile "test/ExampleParsers/Example.fscg"
        putStrLn $ pprint diag
        diagToPdf2 diag "OutputGraphViz/Examples/Parsers/SafeCompositionGraphFunctor/diag"
        putStrLn "End of ExampleSafeCompositionGraphFunctor"
        
        